#####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#####################################################################################
#
# tv.tcl 2.0.1
#
# Author: Drakon_ <drakon@eggdrop.org.ru>
# Modify by: mr_fox <root@hack.su>
#
# official support channel : irc.rinet.ru @ #eggdrop
# 
#####################################################################################
# add 2.0.1 -    
#  2.0  1.3  .
#    -   tv.rambler.ru
#        ;)
#   -    -    
#       
#   +   /  .chanset #chan +/-time
set tv(timer) 300
namespace eval tv {}

setudef flag tv
bind pub - !tv ::tv::pubtv
bind msg - !tv ::tv::msgtv
bind pub - ! ::tv::pubtv
bind msg - ! ::tv::msgtv

set tv(use_proxy) 		0
set tv(proxy_host) 		"proxy1.bezeqint.net"
set tv(proxy_port)		3128
set tv(agent) 			"Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322; .NET CLR 1.0.3705)"
set tv(timeout) 		10

proc ::tv::pubtv {nick uhost hand chan args} {
	if {![channel get $chan tv]} { return }
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::tv::tv $nick $uhost $hand $chan $args
}
proc ::tv::msgtv {nick uhost hand args} {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::tv::tv $nick $uhost $hand $nick $args
}
proc putnot {nick msg} { ::egglib::outn $nick $msg }
proc ::tv::tv {n uh h c i} {
	global tv
set tvtimer [utimers]
 foreach line $tvtimer {
 if {"tv:reset $uh" == [lindex $line 1]} { set tv(time) [lindex $line 0] }
 }
 if { [info exists tv(host,$uh)] } { 
	set temp [duration $tv(time)] 
        	regsub -all -- {hours} $temp {()} temp 
	      regsub -all -- {hour} $temp {} temp 
		regsub -all -- {minutes} $temp {()} temp
        	regsub -all -- {minute} $temp {} temp
		regsub -all -- {seconds} $temp {()} temp
		regsub -all -- {second} $temp {} temp
 if {$tv(timer) > 0} { putserv "NOTICE $n :    !tv  $temp"
 return
 }
 }	
 set tv(host,$uh) 1
 set tv(timer,$uh) [utimer $tv(timer) [list tv:reset $uh ] ]
	if {[llength $i]==0} {
		::egglib::outh $n $c "!tv" "<ort|rtr|tvc|ntv|kult|sport|tvm|tvt|M1|ren|ctc|tv3|mtv|muz|dtv> \[   : 10:00\] \[    : 15:00\]"
       	return
	}
set po [lindex $i 0]
set pr 0
set loct [ctime [unixtime]]
set ploct [clock format [clock seconds] -format "%d.%m.%y"]
		if {[string match "*Mon*" "$loct"]} { set day 1 
set aday "" }
		if {[string match "*Tue*" "$loct"]} { set day 2 
set aday "" }
		if {[string match "*Wed*" "$loct"]} { set day 3 
set aday "" }
		if {[string match "*Thu*" "$loct"]} { set day 4 
set aday "" }
		if {[string match "*Fri*" "$loct"]} { set day 5 
set aday "" }
		if {[string match "*Sat*" "$loct"]} { set day 6 
set aday "" }
		if {[string match "*Sun*" "$loct"]} { set day 7 
set aday "" }
if {[lindex $i 1] != ""} {  
		if {[lindex $i 1] == "1"} { set day 1 
set ploct ""
set aday "" }
		if {[lindex $i 1] == "2"} { set day 2
set ploct ""
set aday "" }
		if {[lindex $i 1] == "3"} { set day 3 
set ploct ""
set aday "" }
		if {[lindex $i 1] == "4"} { set day 4 
set ploct ""
set aday "" }
		if {[lindex $i 1] == "5"} { set day 5
set ploct ""
set aday "" }
		if {[lindex $i 1] == "6"} { set day 6  
set ploct ""
set aday "" }
		if {[lindex $i 1] == "7"} { set day 7
set ploct ""
set aday "" }
}
if {[string match "*ort*" $po]} { set pr 1 
set zag "\002\00306   \00314$ploct\00312 $aday  \00310 "
}
if {[string match "*rtr*" $po]} { set pr 2 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*tvc*" $po]} { set pr 3 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*ntv*" $po]} { set pr 4 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*kult*" $po]} { set pr 5 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*sport*" $po]} { set pr 235
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*tvm*" $po]} { set pr 7
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*tnt*" $po]} { set pr 101 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310"
}
if {[string match "*m1*" $po]} { set pr 102
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \003101"
}
if {[string match "*ren*" $po]} { set pr 103 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310-"
}
if {[string match "*ctc*" $po]} { set pr 104
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310CTC-"
}
if {[string match "*tv3*" $po]} { set pr 105 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \003103"
}
if {[string match "*mtv*" $po]} { set pr 107
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310MTV"
}
if {[string match "*muz*" $po]} { set pr 108 
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310-"
}
if {[string match "*dtv*" $po]} { set pr 109
set zag "\002\00306   \00314$ploct\00312 $aday\00306  \00310DTV"
}
if {$pr==0} {
::egglib::outh $n $c "!tv" "<ort|rtr|tvc|ntv|kult|sport|tvm|tvt|M1|ren|ctc|tv3|mtv|muz|dtv> \[   : 10.00\] \[    : 15.00\]"
return
}

set timez ""
set ktimez ""
if { [regexp -nocase -- {^\d+\:\d+$} [lindex $i 1]] } {
if { [regexp -nocase -- {^(\d+\:\d+)$} [lindex $i 1] tb tb1] } {
set timez [lindex $i 1]
if { [regexp -nocase -- {^(\d+\:\d+)$} [lindex $i 2] tb tb1] } {
set ktimez [lindex $i 2]
}
}
} else {
if {$timez == ""} {
if { [regexp -nocase -- {^(\d+\:\d+)$} [lindex $i 2] tb tb1] } {
set timez [lindex $i 2]
if { [regexp -nocase -- {^(\d+\:\d+)$} [lindex $i 3] tb tb1] } {
set ktimez [lindex $i 3]
}
}
}
}
	set url "http://tv.rambler.ru/index.html?d=[clock format [unixtime] -format "%d-%m-%Y"]&channel_id=$pr"
	set id [::egglib::http_init "::tv::"]
	if { $tv(use_proxy) } { ::egglib::http_set_proxy $id $tv(proxy_host) $tv(proxy_port) }
	::egglib::http_set_timeout $id $tv(timeout)
	::egglib::http_set_agent $id $tv(agent)
  	::egglib::http_get $id $url [list $n $c $uh $pr $zag $timez $ktimez]
}
proc ::tv::on_data {id html nick chan uhost pr zag timez ktimez} {
global tv
::egglib::http_cleanup $id
set html [split $html \n]
set k 0
foreach item $html {
	if {[regexp -nocase -- {<td[^>]*><font[^>]*><b>(.*?)<sup><u>(.*?)</u></sup>\ &ndash;\ (.*?)<sup><u>(.*?)</u></sup></b></font></td>} $item garb a b c d] } { 
set time "$a:$b - $c:$d"
 if { $timez!="" } {
	if { $ktimez!="" } {
		if {[lindex [split $timez :] 0] > $a } { incr k 
continue }
		if {[lindex [split $timez :] 1] > $b } { incr k 
continue }
		if {[lindex [split $ktimez :] 0] < $c } { incr k 
continue }
		if {[lindex [split $ktimez :] 1] < $d } { incr k 
continue }
#putlog "time = $time"
if {[regexp -nocase -- {<td width=[^>]*><font size=[^>]*>*[^>]*>(.*?)<nobr>} [lindex $html [expr $k + 2]] garb opis] } { 
set opis [::egglib::unhtml $opis]
#putlog "$opis"
   }
		} else { 
		if {[lindex [split $timez :] 0] > $a } { incr k 
continue }
		if {[lindex [split $timez :] 1] > $b } { incr k 
continue }
#putlog "time = $time"
if {[regexp -nocase -- {<td width=[^>]*><font size=[^>]*>*[^>]*>(.*?)<nobr>} [lindex $html [expr $k + 2]] garb opis] } { 
set opis [::egglib::unhtml $opis]
putlog "$opis"
   }
		}
		  } else {
#putlog "time = $time"
if {[regexp -nocase -- {<td width=[^>]*><font size=[^>]*>*[^>]*>(.*?)<nobr>} [lindex $html [expr $k + 2]] garb opis] } { 
set opis [::egglib::unhtml $opis]
#putlog "$opis"
   }
		}
lappend obs "\00305 $time \00307 $opis"
					}
incr k					
 }
::egglib::out $nick $nick $zag
foreach item $obs { ::egglib::out $nick $nick "$item" }
}
proc ::tv::on_error { id nick chan uhost } {
	::egglib::out $nick $chan "\0032   tv.rambler.ru.. -.-\003"
}

proc tv:reset { uh } {
 global tv
 catch {killutimer $tv(timer,$uh)}
 catch {unset tv(timer,$uh)}
 catch {unset tv(host,$uh)}
}
putlog "TV version 2.6 (Modify by hunt <hunt@cooldrop.org.ru>)"
